#include <iostream>

using namespace std;

int main(){
	int h,n,l,d;
	cin>>h>>n;
	int p,o;
	int v[h][n];
	int pod[n];
	for(int i=0;i<n;i++){
		pod[i]=1;
	}
	for(int i=0;i<h;i++){
		for(int j=0;j<n;j++){
			cin>>v[i][j];
		}
	}
	for(int i=0;i<h;i++){
		for(int j=0;j<n;j++){
			o=0;
		if(v[i][j]==0){
			l=pod[j]/2;
			d=pod[j]/2;
			if(pod[j]%2==1){
				if(i%2==0){
				l++;
				}
				else{
				d++;
				}
			}
			pod[j]=0;
			for(int jl=j;jl>=0;jl--){
				if(v[i][jl]==1){
					pod[jl]+=l;
					p=jl;
					break;
				}
				if(jl==0){
					o=l;
				}
			}
			for(int jd=j;jd<n;jd++){
				if(v[i][jd]==1){
					pod[jd]=pod[jd]+d+o;
					break;
				}
				if(jd==n-1){
					pod[p]+=d;
			}
			}
		
		}	
		}
		}
		for(int i=0;i<n;i++){
			cout<<pod[i]<<" ";
		}
	}